/**
 * Autogenerated by Thrift Compiler (0.14.0)
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 *  @generated
 */
using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.Extensions.Logging;
using Thrift;
using Thrift.Collections;
using System.ServiceModel;
using System.Runtime.Serialization;

using Thrift.Protocol;
using Thrift.Protocol.Entities;
using Thrift.Protocol.Utilities;
using Thrift.Transport;
using Thrift.Transport.Client;
using Thrift.Transport.Server;
using Thrift.Processor;


#pragma warning disable IDE0079  // remove unnecessary pragmas
#pragma warning disable IDE1006  // parts of the code use IDL spelling

namespace Apache.Cassandra.Test
{

  /// <summary>
  /// The ColumnPath is the path to a single column in Cassandra. It might make sense to think of ColumnPath and
  /// ColumnParent in terms of a directory structure.
  /// 
  /// ColumnPath is used to looking up a single column.
  /// 
  /// @param column_family. The name of the CF of the column being looked up.
  /// @param super_column. The super column name.
  /// @param column. The column name.
  /// </summary>
  [DataContract(Namespace="")]
  public partial class ColumnPath : TBase
  {
    private byte[] _super_column;
    private byte[] _column;

    [DataMember(Order = 0)]
    public string Column_family { get; set; }

    [DataMember(Order = 0)]
    public byte[] Super_column
    {
      get
      {
        return _super_column;
      }
      set
      {
        __isset.super_column = true;
        this._super_column = value;
      }
    }

    [DataMember(Order = 0)]
    public byte[] Column
    {
      get
      {
        return _column;
      }
      set
      {
        __isset.column = true;
        this._column = value;
      }
    }


    [DataMember(Order = 1)]
    public Isset __isset;
    [DataContract]
    public struct Isset
    {
      [DataMember]
      public bool super_column;
      [DataMember]
      public bool column;
    }

    #region XmlSerializer support

    public bool ShouldSerializeSuper_column()
    {
      return __isset.super_column;
    }

    public bool ShouldSerializeColumn()
    {
      return __isset.column;
    }

    #endregion XmlSerializer support

    public ColumnPath()
    {
    }

    public ColumnPath(string column_family) : this()
    {
      this.Column_family = column_family;
    }

    public ColumnPath DeepCopy()
    {
      var tmp34 = new ColumnPath();
      if((Column_family != null))
      {
        tmp34.Column_family = this.Column_family;
      }
      if((Super_column != null) && __isset.super_column)
      {
        tmp34.Super_column = this.Super_column.ToArray();
      }
      tmp34.__isset.super_column = this.__isset.super_column;
      if((Column != null) && __isset.column)
      {
        tmp34.Column = this.Column.ToArray();
      }
      tmp34.__isset.column = this.__isset.column;
      return tmp34;
    }

    public async global::System.Threading.Tasks.Task ReadAsync(TProtocol iprot, CancellationToken cancellationToken)
    {
      iprot.IncrementRecursionDepth();
      try
      {
        bool isset_column_family = false;
        TField field;
        await iprot.ReadStructBeginAsync(cancellationToken);
        while (true)
        {
          field = await iprot.ReadFieldBeginAsync(cancellationToken);
          if (field.Type == TType.Stop)
          {
            break;
          }

          switch (field.ID)
          {
            case 3:
              if (field.Type == TType.String)
              {
                Column_family = await iprot.ReadStringAsync(cancellationToken);
                isset_column_family = true;
              }
              else
              {
                await TProtocolUtil.SkipAsync(iprot, field.Type, cancellationToken);
              }
              break;
            case 4:
              if (field.Type == TType.String)
              {
                Super_column = await iprot.ReadBinaryAsync(cancellationToken);
              }
              else
              {
                await TProtocolUtil.SkipAsync(iprot, field.Type, cancellationToken);
              }
              break;
            case 5:
              if (field.Type == TType.String)
              {
                Column = await iprot.ReadBinaryAsync(cancellationToken);
              }
              else
              {
                await TProtocolUtil.SkipAsync(iprot, field.Type, cancellationToken);
              }
              break;
            default: 
              await TProtocolUtil.SkipAsync(iprot, field.Type, cancellationToken);
              break;
          }

          await iprot.ReadFieldEndAsync(cancellationToken);
        }

        await iprot.ReadStructEndAsync(cancellationToken);
        if (!isset_column_family)
        {
          throw new TProtocolException(TProtocolException.INVALID_DATA);
        }
      }
      finally
      {
        iprot.DecrementRecursionDepth();
      }
    }

    public async global::System.Threading.Tasks.Task WriteAsync(TProtocol oprot, CancellationToken cancellationToken)
    {
      oprot.IncrementRecursionDepth();
      try
      {
        var struc = new TStruct("ColumnPath");
        await oprot.WriteStructBeginAsync(struc, cancellationToken);
        var field = new TField();
        if((Column_family != null))
        {
          field.Name = "column_family";
          field.Type = TType.String;
          field.ID = 3;
          await oprot.WriteFieldBeginAsync(field, cancellationToken);
          await oprot.WriteStringAsync(Column_family, cancellationToken);
          await oprot.WriteFieldEndAsync(cancellationToken);
        }
        if((Super_column != null) && __isset.super_column)
        {
          field.Name = "super_column";
          field.Type = TType.String;
          field.ID = 4;
          await oprot.WriteFieldBeginAsync(field, cancellationToken);
          await oprot.WriteBinaryAsync(Super_column, cancellationToken);
          await oprot.WriteFieldEndAsync(cancellationToken);
        }
        if((Column != null) && __isset.column)
        {
          field.Name = "column";
          field.Type = TType.String;
          field.ID = 5;
          await oprot.WriteFieldBeginAsync(field, cancellationToken);
          await oprot.WriteBinaryAsync(Column, cancellationToken);
          await oprot.WriteFieldEndAsync(cancellationToken);
        }
        await oprot.WriteFieldStopAsync(cancellationToken);
        await oprot.WriteStructEndAsync(cancellationToken);
      }
      finally
      {
        oprot.DecrementRecursionDepth();
      }
    }

    public override bool Equals(object that)
    {
      if (!(that is ColumnPath other)) return false;
      if (ReferenceEquals(this, other)) return true;
      return System.Object.Equals(Column_family, other.Column_family)
        && ((__isset.super_column == other.__isset.super_column) && ((!__isset.super_column) || (TCollections.Equals(Super_column, other.Super_column))))
        && ((__isset.column == other.__isset.column) && ((!__isset.column) || (TCollections.Equals(Column, other.Column))));
    }

    public override int GetHashCode() {
      int hashcode = 157;
      unchecked {
        if((Column_family != null))
        {
          hashcode = (hashcode * 397) + Column_family.GetHashCode();
        }
        if((Super_column != null) && __isset.super_column)
        {
          hashcode = (hashcode * 397) + Super_column.GetHashCode();
        }
        if((Column != null) && __isset.column)
        {
          hashcode = (hashcode * 397) + Column.GetHashCode();
        }
      }
      return hashcode;
    }

    public override string ToString()
    {
      var sb = new StringBuilder("ColumnPath(");
      if((Column_family != null))
      {
        sb.Append(", Column_family: ");
        Column_family.ToString(sb);
      }
      if((Super_column != null) && __isset.super_column)
      {
        sb.Append(", Super_column: ");
        Super_column.ToString(sb);
      }
      if((Column != null) && __isset.column)
      {
        sb.Append(", Column: ");
        Column.ToString(sb);
      }
      sb.Append(')');
      return sb.ToString();
    }
  }

}
